﻿Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition
Imports System.Windows.Forms
<Serializable()>
Public Class CustomGoogleLayer
   Inherits GoogleMapsLayer
   <NonSerialized()>
   Private moMap As CustomWinFormsMap
   Public Shared ContiguousStatesExtentGoogle As New RectangleShape(-13931965, 46494668, -7494592, 42902614)
   Public Property GoogleApiKey As String = mcsDefaultAPIKey
   Private Const mcsDefaultAPIKey As String = "< put your Google Maps API key here >"
   Public Sub New(oMap As CustomWinFormsMap)
      MyBase.New()
      moMap = oMap
   End Sub
   Public ReadOnly Property IsProjected As Boolean
      Get
         Return Not ProjectionFromSphericalMercator Is Nothing
      End Get
   End Property

   Public Function ContiguousStatesExtent() As RectangleShape
      If Map.SRID = 3857 Then
         Return CustomGoogleLayer.ContiguousStatesExtentGoogle
      Else
         Dim oProj4 As ManagedProj4Projection = CType(Me.ProjectionFromSphericalMercator, ManagedProj4Projection)
         oProj4.Open()
         Return oProj4.ConvertToExternalProjection(CustomGoogleLayer.ContiguousStatesExtentGoogle)
      End If

   End Function
   Public Property Map As CustomWinFormsMap
      Get
         Return moMap
      End Get
      Set(value As CustomWinFormsMap)
         moMap = value
      End Set
   End Property
   Protected Overrides Sub OnCreatingRequest(e As ThinkGeo.MapSuite.Core.CreatingRequestGoogleMapsLayerEventArgs)
      e.RequestUri = New Uri(e.RequestUri.AbsoluteUri + "&key=" + GoogleApiKey)
      MyBase.OnCreatingRequest(e)
   End Sub
   Public Sub SetCoordinateSystem()
      If Map.SRID <> 3857 Then
         Dim oProj4 As New ManagedProj4Projection
         With oProj4
            .InternalProjectionParametersString = GetProjParameterString(3857)
            .ExternalProjectionParametersString = GetProjParameterString(Map.SRID)
            oProj4.Open()
            Me.ProjectionFromSphericalMercator = oProj4
         End With
      Else
         '***** Setting this property to Nothing when it already is
         '***** causes an exception to be thrown.
         If Me.ProjectionFromSphericalMercator IsNot Nothing Then
            Me.ProjectionFromSphericalMercator = Nothing
         End If
      End If
   End Sub
   Private Function GetProjParameterString(iSRID As Integer) As String
      Dim sParameters As String = String.Empty

      sParameters = ManagedProj4Projection.GetEsriParametersString(iSRID)

      If sParameters = String.Empty Then
         sParameters = ManagedProj4Projection.GetEpsgParametersString(iSRID)
      End If

      Return sParameters

   End Function
End Class

