﻿Imports ThinkGeo.MapSuite.Core
Imports System.IO
Imports System.Runtime.Serialization.Formatters.Binary
<Serializable()>
Public Class StyleCollection
   Inherits System.Collections.ObjectModel.KeyedCollection(Of String, Style)
   Private Shared msPath As String = "..\..\Data\SavedAreaStyles.dat"
   Protected Overrides Function GetKeyForItem(ByVal item As Style) As String
      Return item.Name
   End Function
   Public Shared Function SerializeStyleCollection(oStyleCollection As StyleCollection) As Boolean
      Dim bSuccess As Boolean = False
      Dim oFormatter As BinaryFormatter
      Dim oStream As Stream
      Dim oObjectToSerialize As Object = oStyleCollection

      If oObjectToSerialize Is Nothing Then
         Return bSuccess
      End If

      '***** Open a file stream to use for serialization
      oFormatter = New BinaryFormatter()

      oStream = New FileStream(msPath, FileMode.Create, FileAccess.Write, FileShare.None)

      Try
         oFormatter.Serialize(oStream, oObjectToSerialize)
         oStream.Close()
         bSuccess = True
      Catch ex As System.IO.IOException
         MessageBox.Show("IO Exception Raised:" & ControlChars.CrLf & ex.Message, "Serialize", MessageBoxButtons.OK, MessageBoxIcon.Error)
      Catch ex As Exception
         MessageBox.Show("Exception Raised:" & ControlChars.CrLf & ex.Message, "Serialize", MessageBoxButtons.OK, MessageBoxIcon.Error)
      Finally
         bSuccess = True
         If Not oStream Is Nothing Then
            oStream.Close()
         End If
      End Try
      Return bSuccess
   End Function
   Public Shared Function DeSerializeStyleCollection() As Object
      Dim bSuccess As Boolean = True
      Dim oStream As Stream = Nothing
      Dim oFormatter As BinaryFormatter
      Dim oListToSerialize As Object = Nothing

      '***** Open a file stream to use for deserialization
      oFormatter = New BinaryFormatter()

      Try
         If Not File.Exists(msPath) Then
            bSuccess = False
            Exit Try
         End If
         oStream = New FileStream(msPath, FileMode.Open, FileAccess.Read, FileShare.Read)
         oListToSerialize = oFormatter.Deserialize(oStream)

      Catch ex As System.Xml.XmlException
         MessageBox.Show(ex.Message)
         bSuccess = False
      Catch ex As Exception
         MessageBox.Show(ex.Message)
         bSuccess = False
      Finally
         If Not oStream Is Nothing Then
            oStream.Close()
         End If
      End Try

      Return oListToSerialize
   End Function

End Class
